----------------------------------------------------------------------------------
-- Company:
-- Engineer: IGNACIO SERNA ESCOBEDO & SANTIAGO VIVES MERINO
-- 
-- Create Date: 17.12.2019
-- Design Name:
-- Module Name: CONDITIONER - STRUCTURAL
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision: 16.01.2020
-- Additional Comments:
-- 
----------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity CONDITIONER is
	generic(
		CONDITIONER_N : positive := 1;
		CONDITIONER_SYNCHRONIZER_INDEX : positive := 2;
		CONDITIONER_DEBOUNCER_DELAY : positive := 1000
	);
	port(
		CONDITIONER_INPUT_CLOCK : in std_logic;
		CONDITIONER_INPUT_MODE : in std_logic;
		CONDITIONER_INPUT_RESET : in std_logic;
		CONDITIONER_INPUT_START_PAUSE : in std_logic;
		CONDITIONER_INPUT_MASTER_RESET : in std_logic;
		CONDITIONER_OUTPUT_MODE : out std_logic;
		CONDITIONER_OUTPUT_RESET : out std_logic;
		CONDITIONER_OUTPUT_START_PAUSE : out std_logic;
		CONDITIONER_OUTPUT_MASTER_RESET : out std_logic
	);
end entity CONDITIONER;

architecture STRUCTURAL of CONDITIONER is
	component SYNCHRONIZER
		generic(
			SYNCHRONIZER_N : positive := 1;
			SYNCHRONIZER_INDEX : positive := 2
		);
		port (
			SYNCHRONIZER_CLOCK : in std_logic;
			SYNCHRONIZER_INPUT : in std_logic_vector(SYNCHRONIZER_N-1 downto 0);
			SYNCHRONIZER_RESET : in std_logic;
			SYNCHRONIZER_OUTPUT : out std_logic_vector(SYNCHRONIZER_N-1 downto 0)
		);
	end component;
	component DEBOUNCER
		generic (
			DEBOUNCER_N : positive := 1;
			DEBOUNCER_DELAY : positive := 1000
		);
		port (
			DEBOUNCER_CLOCK : in std_logic;
			DEBOUNCER_INPUT : in std_logic_vector(DEBOUNCER_N-1 downto 0);
			DEBOUNCER_RESET : in std_logic;
			DEBOUNCER_OUTPUT : out std_logic_vector(DEBOUNCER_N-1 downto 0)
		);
	end component;
	signal SYNCHRONIZED_MODE: std_logic_vector(CONDITIONER_N-1 downto 0);
	signal SYNCHRONIZED_RESET: std_logic_vector(CONDITIONER_N-1 downto 0);
	signal SYNCHRONIZED_START_PAUSE: std_logic_vector(CONDITIONER_N-1 downto 0);
	signal SYNCHRONIZED_MASTER_RESET: std_logic_vector(CONDITIONER_N-1 downto 0);
	signal DEBOUNCED_MODE: std_logic_vector(CONDITIONER_N-1 downto 0);
	signal DEBOUNCED_RESET: std_logic_vector(CONDITIONER_N-1 downto 0);
	signal DEBOUNCED_START_PAUSE: std_logic_vector(CONDITIONER_N-1 downto 0);
	signal DEBOUNCED_MASTER_RESET: std_logic_vector(CONDITIONER_N-1 downto 0);
begin
	--STAGE 1: SYNCHRONIZER
	SYNCHRONIZER_MODE: SYNCHRONIZER
		generic map(
			SYNCHRONIZER_N    		=> CONDITIONER_N,
			SYNCHRONIZER_INDEX		=> CONDITIONER_SYNCHRONIZER_INDEX
		)
		port map(
			SYNCHRONIZER_CLOCK		=> CONDITIONER_INPUT_CLOCK,  
			SYNCHRONIZER_INPUT(0)	=> CONDITIONER_INPUT_MODE, 
			SYNCHRONIZER_RESET		=> DEBOUNCED_MASTER_RESET(0), 
			SYNCHRONIZER_OUTPUT		=> SYNCHRONIZED_MODE
		);
	SYNCHRONIZER_RESET: SYNCHRONIZER
		generic map(
			SYNCHRONIZER_N    		=> CONDITIONER_N,
			SYNCHRONIZER_INDEX		=> CONDITIONER_SYNCHRONIZER_INDEX
		)
		port map(
			SYNCHRONIZER_CLOCK		=> CONDITIONER_INPUT_CLOCK,  
			SYNCHRONIZER_INPUT(0)	=> CONDITIONER_INPUT_RESET, 
			SYNCHRONIZER_RESET		=> DEBOUNCED_MASTER_RESET(0), 
			SYNCHRONIZER_OUTPUT		=> SYNCHRONIZED_RESET
		);
	SYNCHRONIZER_START_PAUSE: SYNCHRONIZER
		generic map(
			SYNCHRONIZER_N    		=> CONDITIONER_N,
			SYNCHRONIZER_INDEX		=> CONDITIONER_SYNCHRONIZER_INDEX
		)
		port map(
			SYNCHRONIZER_CLOCK		=> CONDITIONER_INPUT_CLOCK,  
			SYNCHRONIZER_INPUT(0)	=> CONDITIONER_INPUT_START_PAUSE, 
			SYNCHRONIZER_RESET		=> DEBOUNCED_MASTER_RESET(0), 
			SYNCHRONIZER_OUTPUT		=> SYNCHRONIZED_START_PAUSE
		);
	SYNCHRONIZER_MASTER_RESET: SYNCHRONIZER
		generic map(
			SYNCHRONIZER_N    		=> CONDITIONER_N,
			SYNCHRONIZER_INDEX		=> CONDITIONER_SYNCHRONIZER_INDEX
		)
		port map(
			SYNCHRONIZER_CLOCK		=> CONDITIONER_INPUT_CLOCK,  
			SYNCHRONIZER_INPUT(0)	=> CONDITIONER_INPUT_MASTER_RESET, 
			SYNCHRONIZER_RESET		=> DEBOUNCED_MASTER_RESET(0), 
			SYNCHRONIZER_OUTPUT		=> SYNCHRONIZED_MASTER_RESET
		);
	--STAGE 2: DEBOUNCER
	DEBOUNCER_MODE:DEBOUNCER
		generic map(
			DEBOUNCER_N				=> CONDITIONER_N,
			DEBOUNCER_DELAY			=> CONDITIONER_DEBOUNCER_DELAY
		)
		port map(
			DEBOUNCER_CLOCK			=> CONDITIONER_INPUT_CLOCK,  
			DEBOUNCER_INPUT			=> SYNCHRONIZED_MODE, 
			DEBOUNCER_RESET			=> DEBOUNCED_MASTER_RESET(0), 
			DEBOUNCER_OUTPUT		=> DEBOUNCED_MODE
		);
	DEBOUNCER_RESET:DEBOUNCER
		generic map(
			DEBOUNCER_N				=> CONDITIONER_N,
			DEBOUNCER_DELAY			=> CONDITIONER_DEBOUNCER_DELAY
		)            
		port map(
			DEBOUNCER_CLOCK			=> CONDITIONER_INPUT_CLOCK,  
			DEBOUNCER_INPUT			=> SYNCHRONIZED_RESET, 
			DEBOUNCER_RESET			=> DEBOUNCED_MASTER_RESET(0), 
			DEBOUNCER_OUTPUT		=> DEBOUNCED_RESET
		);
	DEBOUNCER_START_PAUSE:DEBOUNCER
		generic map(
			DEBOUNCER_N				=> CONDITIONER_N,
			DEBOUNCER_DELAY			=> CONDITIONER_DEBOUNCER_DELAY
		)
		port map(
			DEBOUNCER_CLOCK			=> CONDITIONER_INPUT_CLOCK,  
			DEBOUNCER_INPUT			=> SYNCHRONIZED_START_PAUSE, 
			DEBOUNCER_RESET			=> DEBOUNCED_MASTER_RESET(0), 
			DEBOUNCER_OUTPUT		=> DEBOUNCED_START_PAUSE
		);
	DEBOUNCER_MASTER_RESET:DEBOUNCER
		generic map(
			DEBOUNCER_N				=> CONDITIONER_N,
			DEBOUNCER_DELAY			=> CONDITIONER_DEBOUNCER_DELAY
		)
		port map(
			DEBOUNCER_CLOCK			=> CONDITIONER_INPUT_CLOCK,  
			DEBOUNCER_INPUT			=> SYNCHRONIZED_MASTER_RESET, 
			DEBOUNCER_RESET			=> DEBOUNCED_MASTER_RESET(0), 
			DEBOUNCER_OUTPUT		=> DEBOUNCED_MASTER_RESET
		);
	--STAGE 2: OUTPUTS
	CONDITIONER_OUTPUT_MODE			<= DEBOUNCED_MODE(0);
	CONDITIONER_OUTPUT_RESET		<= DEBOUNCED_RESET(0);
	CONDITIONER_OUTPUT_START_PAUSE	<= DEBOUNCED_START_PAUSE(0);
	CONDITIONER_OUTPUT_MASTER_RESET	<= DEBOUNCED_MASTER_RESET(0);
end architecture STRUCTURAL;